#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JSDR.
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef	__AM_PROCESSOR
#define	__AM_PROCESSOR

#include	"jff-include.h"
#include	"iir-filters.h"
#include	"utilities.h"
#include	<QObject>
#include	"agchandler.h"
class		RadioInterface;
class		pllC;

class	amProcessor: public QObject {
Q_OBJECT
public:
		amProcessor	(RadioInterface *, int32_t);
		~amProcessor	(void);
	void	processAM	(DSPCOMPLEX *, DSPCOMPLEX *);
	int32_t	setBandwidth	(int32_t);
	void	setVolume	(int32_t);
	enum amDecoderType {
	   ENVELOPE_DETECTOR_1	= 1,
	   ENVELOPE_DETECTOR_2	= 2,
	   SYNCHRONOUS_DETECTOR = 4
	};
	void	setDecoder	(amDecoderType);
	void	setAgc		(uint8_t);
	void	setAgcLevel	(int16_t);
	void	setAgcThresholdSlider	(int16_t);
private:
	RadioInterface	*myRadioInterface;
	int32_t		WorkingRate;
	int32_t		cycleCount;
	int32_t		amBandwidth;
	pllC		*am_pll;
	DSPFLOAT	am_w1;
	DSPFLOAT	am_w0;
	DSPFLOAT	currLock;
	DSPFLOAT	prevLock;
	DSPFLOAT	amDc;
	DSPFLOAT	amSmooth;

	DSPFLOAT	Volume;
	agcHandler	*agc;
	amDecoderType	amDecoder;
signals:
	void		amShiftFreq	(float);
	void		amStrength	(float);
	void		amshowAgc	(float);
};

#endif

