#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JSDR.
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include	"sound_processor.h"

	soundProcessor::soundProcessor (int32_t rate,
	                                int16_t toneLeft,
	                                int16_t toneRight) {
int32_t	i;
	this	-> CardRate		= rate;
	this	-> toneLeft		= toneLeft;
	this	-> IndexforToneLeft	= 0;
	this	-> toneRight		= toneRight;
	this	-> IndexforToneRight	= 0;
	this	-> table		= new DSPCOMPLEX [CardRate];
	for (i = 0; i < CardRate; i ++)
	   table [i] = DSPCOMPLEX (cos (2 * M_PI * i / CardRate),
	                           sin (2 * M_PI * i / CardRate));

	this	-> upFilter		= new LowPassIIR (9,
	                                                  15000,
	                                                  CardRate,
	                                                  S_BUTTERWORTH);
}

	soundProcessor::~soundProcessor (void) {
	delete[]	table;
	delete		upFilter;
}

void	soundProcessor::makeSound (DSPCOMPLEX v, DSPCOMPLEX *o) {
uint16_t	i;
DSPCOMPLEX	a;

	IndexforToneLeft = (IndexforToneLeft + toneLeft) % CardRate;
	IndexforToneRight = (IndexforToneRight + toneRight) % CardRate;
	a = DSPCOMPLEX (real (table [IndexforToneLeft]),
	                 imag (table [IndexforToneRight]));
	*o = upFilter -> Pass (a);
}


