#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef	SPECTRUM_CONSTANTS
#define	SPECTRUM_CONSTANTS

//	for main.cpp we define
#define	MISERY		"/tmp/misery"
#define	BASE		getenv ("HOME")
#define	DEFAULT_INI	".jsdr-spectrum.ini"

//	for gui.cpp we define
#ifdef __MINGW32__
#define	REPEAT_RATE		8
#define	SPECTRUM_WIDTH		8192
#define	FE_DISPLAYSIZE		512
#define	RASTER			50
#else
#define	REPEAT_RATE		10
#define	SPECTRUM_WIDTH		(2 * 16384)
#define	FE_DISPLAYSIZE		2048
#define	RASTER			100
#endif

#define	MSECFORTIMER	10
//
//	defined in Khz
#define	SPECTRUM_MIN_LOOP_FREQUENCY	86500
#define	SPECTRUM_MAX_LOOP_FREQUENCY	1000000

#endif

