#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __TUNER_FC0012_H
#define __TUNER_FC0012_H

#define FC0012_OK	0
#define FC0012_ERROR	1

#define FC0012_I2C_ADDR		0xc6
#define FC0012_CHECK_ADDR	0x00
#define FC0012_CHECK_VAL	0xa1

#define FC0012_BANDWIDTH_6MHZ	6
#define FC0012_BANDWIDTH_7MHZ	7
#define FC0012_BANDWIDTH_8MHZ	8

#define FC0012_LNA_GAIN_LOW	0x00
#define FC0012_LNA_GAIN_MID	0x08
#define FC0012_LNA_GAIN_HI	0x17
#define FC0012_LNA_GAIN_MAX	0x10

class	RTL2832U;
//#define	DEBUG

class	TUNER_FC0012:public virtual_tuner {
public:
	TUNER_FC0012	(RTL2832U *);
	~TUNER_FC0012	(void);

	int32_t		init	(void);
	int32_t		exit	(void);
	int32_t		tune	(uint32_t);
	int32_t		set_bw	(int32_t);
	bool		legalFrequency	(uint32_t);
private:
#ifdef	DEBUG
	void		FC0012_Dump_Registers	(void);
#endif
	int32_t	 	FC0012_Open	(void);
	int32_t		FC0012_Read	(uint8_t RegAddr, uint8_t *pByte);
	int32_t		FC0012_Write	(uint8_t RegAddr, uint8_t Byte);
	int32_t		FC0012_SetFrequency (unsigned long Frequency,
	                                     unsigned short Bandwidth);

	RTL2832U	*env_class;
};

#endif
