/*
 * Fitipower FC0013 tuner driver, taken from the kernel driver that can be found
 * on http://linux.terratec.de/tv_en.html
 *
 * This driver is a mess, and should be cleaned up/rewritten.
 *
 */

#include	<stdint.h>
#include	"j-tuner_fc0013.h"
#include	<stdio.h>
#include	"rtl2832u.h"
#define CRYSTAL_FREQ		28800000
//
//	for use with the jsdr software, we made the
//	tuner into a class, that derives from a
//	virtual_tuner class and takes as parameter
//	the rtl class that provides for writing and reading

	TUNER_FC0013::TUNER_FC0013 (RTL2832U *env) {
	env_class	= env;
//	Frequency	= 0;
	Frequency	= FC0013_RF_FREQ_HZ_DEFAULT;
}

	TUNER_FC0013::~TUNER_FC0013 (void) {
}

//	we pass a reference to the class such that we
//	have a handle for reading and wring the bus
int32_t		TUNER_FC0013:: FC0013_Write (uint8_t RegAddr,
	                                     uint8_t Byte) {
uint8_t data[2];
int32_t	tmp;

	data[0] = RegAddr;
	data[1] = Byte;

	tmp = env_class -> i2cWrite (FC0013_I2C_ADDR, data, 2);
	if (tmp < 0)
	   return FC0013_I2C_ERROR;

	return FC0013_I2C_SUCCESS;
}

int32_t		TUNER_FC0013::FC0013_Read (uint8_t RegAddr,
	                                   uint8_t *pByte) {
uint8_t data = RegAddr;
int32_t	tmp;

	tmp = env_class -> i2cWrite (FC0013_I2C_ADDR, &data, 1);
	if (tmp < 0)
	   return FC0013_I2C_ERROR;

	tmp = env_class ->  i2cRead (FC0013_I2C_ADDR, &data, 1);
	if (tmp < 0)
	   return FC0013_I2C_ERROR;
	*pByte = data;
	return FC0013_I2C_SUCCESS;
}
//
//	most registers need to get some kind of update,
//	a combination of read  v and then (v & e) | f
//	structure
bool	TUNER_FC0013::FC0013_update (uint8_t RegAddr,
	                             uint8_t e, uint8_t f) {
uint8_t	read_byte;
int32_t	tmp;
	tmp	= FC0013_Read (RegAddr, &read_byte);
	if (tmp != FC0013_I2C_SUCCESS)
	   return false;
	tmp	= FC0013_Write (RegAddr, (read_byte & e) | f);
	if (tmp != FC0013_I2C_SUCCESS)
	   return false;
	return true;
}

//
//	I always forget whether unsigned long = uint64 or uint32

int32_t		TUNER_FC0013::FC0013_SetVhfTrack (uint32_t FrequencyKHz) {
uint8_t	tmp;
int	ret	= 0;

	if (FC0013_Read (0x1d, &tmp) != FC0013_I2C_SUCCESS)
	   goto error_out;

	tmp	&= 0xe3;
	if (FrequencyKHz <= 177500) {	// VHF Track: 7
	   ret = FC0013_Write (0x1d, tmp | 0x1c);
	}
	else
	if (FrequencyKHz <= 184500) {	// VHF Track: 6
	   ret = FC0013_Write (0x1d,  tmp | 0x18);
	}
	else
	if (FrequencyKHz <= 191500) {	// VHF Track: 5
	   ret = FC0013_Write (0x1d, tmp | 0x14);
	}
	else
	if (FrequencyKHz <= 198500) {	// VHF Track: 4
	   ret = FC0013_Write (0x1d, tmp | 0x10);
	}
	else
	if (FrequencyKHz <= 205500) {	// VHF Track: 3
	   ret = FC0013_Write (0x1d, tmp | 0x0C);
	}
	else
	if (FrequencyKHz <= 212500) {	// VHF Track: 2
	   ret = FC0013_Write (0x1d, tmp | 0x08);
	}
	else
	if (FrequencyKHz <= 219500) {	// VHF Track: 2
	   ret = FC0013_Write (0x1d, tmp | 0x08);
	}
	else
	if (FrequencyKHz <= 300000) {	// VHF Track: 1
	   ret = FC0013_Write (0x1d, tmp | 0x04);
	}
	else {	// UHF and GPS
	   ret = FC0013_Write (0x1d, tmp | 0x1C);
	}

	if (ret == FC0013_I2C_SUCCESS)
	   return FC0013_FUNCTION_SUCCESS;

error_out:
	return FC0013_FUNCTION_ERROR;
}

// FC0013 Open Function, includes enable/reset pin control and registers initialization.
//void FC0013_Open()
//	I liked the code of Hans Frieder Vogt, so this is a mixture
//	of the code from the rtlsdr/osmocom and his code
int32_t	TUNER_FC0013::FC0013_Open (void) {
int32_t	tmp;
uint32_t	i;
//
uint8_t	reg [] = {	// default initial values for registers
	0x00,	// register	0x00, dummy
	0x09,	// register	0x01
	0x16,	// register	0x02
	0x00,	// register	0x03
	0x00,	// register	0x04
	0x17,	// register	0x05
	0x02,	// register	0x06
//	0x2a,	// register	0x07
	0x0a,	// register	0x07	CHECK
	0xff,	// register	0x08: AGC clock divide by 256, AGC gain 1/256
		//	 	      Loop bw 1/8
	0x6f,	// register	0x09: enable loopthrough
	0xb8,	// register	0x0a: disable LO testbuffer
	0x82,	// register	0x0b: CHECK
	0xfc,	// register	0x0c: depending on AGC up-down mode, maybe 0cf8
	0x01,	// register	0x0d: AGC not forcing & LNA forcing, maybe 0x02
	0x00,	// register	0x0e
	0x00,	// register	0x0f
	0x00,	// register	0x10
	0x00,	// register	0x11
	0x00,	// register	0x12
	0x00,	// register	0x13
	0x50,	// register	0x14: DVB-t High gain, UHF (Middle = 0x48, Low = 0x40)
	0x01	// register	0x15
};

	reg [0x07]	|= 0x20;		//XTAL 288000
	reg [0x0c]	|= 0x02;

	for (i = 1; i < sizeof (reg); i ++) 
	   if (FC0013_Write (i, reg [i]) != FC0013_I2C_SUCCESS)
	      goto error_status;

	return FC0013_FUNCTION_SUCCESS;

error_status:
	return FC0013_FUNCTION_ERROR;
}


int32_t	TUNER_FC0013::FC0013_SetFrequency (uint32_t Frequency,
	                                   uint32_t Bandwidth) {
bool	VCO1 = false;
//	unsigned int doubleVCO;
//	unsigned short xin, xdiv;
//	unsigned char reg[21], am, pm, multi;
uint64_t doubleVCO;
unsigned short xin, xdiv;
uint8_t reg [21], am, pm, multi;
uint8_t read_byte;
uint32_t CrystalFreqKhz;
int32_t CrystalFreqHz = CRYSTAL_FREQ;
int32_t	tmp;
int	i;
int	ret;
uint8_t	reg0x07, reg0x14;

	// Get tuner crystal frequency in KHz.
	// Note: CrystalFreqKhz = round(CrystalFreqHz / 1000)
	CrystalFreqKhz = (CrystalFreqHz + 500) / 1000;

	if (!FC0013_update (0x1D, 0xE3, 0x1C))
	   goto error_status;

	tmp = FC0013_SetVhfTrack (Frequency);
	if (tmp != FC0013_I2C_SUCCESS)
	   goto error_status;
//
//	Local optimization: we start with reading reg0x7 and 0x14
//	since in all cases we update their value
	if (FC0013_Read (0x07, &reg0x07) != FC0013_I2C_SUCCESS)
	   goto error_status;
	if (FC0013_Read (0x14, &reg0x14) != FC0013_I2C_SUCCESS)
	   goto error_status;

	if (Frequency < 300000) {	// VHF track
	// Enable VHF filter.
	   if (FC0013_Write (0x07, (reg0x07 | 0x10)) != FC0013_I2C_SUCCESS)
	       goto error_status;
	// Disable UHF & disable GPS.
	   if (FC0013_Write (0x14,  (reg0x14 & 0x1F)) != FC0013_I2C_SUCCESS)
	       goto error_status;
	}
	else if (Frequency <= 862000)  {
	// Disable VHF filter.
	   if (FC0013_Write (0x07, (reg0x07 & 0xEF)) != FC0013_I2C_SUCCESS)
	       goto error_status;
	   // enable UHF & disable GPS.
	   if (FC0013_Write (0x14, (reg0x14 & 0x1F) | 0x40) != FC0013_I2C_SUCCESS)
	      goto error_status;
	}
	else if (Frequency > 862000) {
	// Disable VHF filter
	   if (FC0013_Write (0x07,  (reg0x07 & 0xEF)) != FC0013_I2C_SUCCESS)
	      goto error_status;
	// Disable UHF & enable GPS
	   if (FC0013_Write (0x14,  (reg0x14 & 0x1F) | 0x20) != FC0013_I2C_SUCCESS)
	      goto error_status;
	}
//
//	select frequency divider and vfo frequency
//
	if (Frequency * 96 < 3560000) {		// 37084
           multi = 96;
           reg[5] = 0x82;
           reg[6] = 0x00;
	}
	else
	if (Frequency * 64 < 3560000) {		// 55625
           multi = 64;
           reg[5] = 0x02;
           reg[6] = 0x02;
	}
	else
	if (Frequency * 48 < 3560000) {		// 74167
           multi = 48;
           reg[5] = 0x42;
           reg[6] = 0x00;
	}
	else
	if (Frequency * 32 < 3560000) {		// 111250
	   multi = 32;
	   reg [5] = 0x82;
	   reg [6] = 0x02;
	}
	else
	if (Frequency * 24 < 3560000) {		// 148334
           multi = 24;
           reg[5] = 0x22;
           reg[6] = 0x00;
	}
	else
	if (Frequency * 16 < 3560000) {		// 222500
	   multi = 16;
	   reg [5] = 0x42;
	   reg [6] = 0x02;
	}
	else
	if (Frequency * 12 < 3560000) {		// 296667
	   multi = 12;
 	   reg [5] = 0x12;
	   reg [6] = 0x00;
	}
	else
	if (Frequency * 8 < 3560000) {		// 445000
	   multi = 8;
	   reg [5] = 0x22;
	   reg [6] = 0x02;
 	}
	else
	if (Frequency * 6 < 3560000) {		// 593334
	   multi = 6;
	   reg [5] = 0x0A;
	   reg [6] = 0x00;
	}
	else
	if (Frequency * 4 < 3800000) {		// 950000
	   multi = 4;
	   reg [5] = 0x12;
	   reg [6] = 0x02;
	}
	else {
	   Frequency = Frequency / 2;
	   multi = 4;
	   reg [5] = 0x0A;
	   reg [6] = 0x02;
	}

	doubleVCO = Frequency * multi;
	if (doubleVCO >= 3060000) {
	   reg [6] = reg[6] | 0x08;
	   VCO1 = true;
	}

	if (Frequency >= 45000) {
// Calculate VCO parameters: ap & pm & xin.
	   xdiv = (unsigned short)(doubleVCO / (CrystalFreqKhz / 2));
	   if ((doubleVCO - xdiv * (CrystalFreqKhz / 2)) >=
	                                            (CrystalFreqKhz / 4)) 
	      xdiv = xdiv + 1;
	   pm = (uint8_t)( xdiv / 8 );
	   am = (uint8_t)( xdiv - (8 * pm));

	   if (am < 2) {
              reg [1] = am + 8;
              reg [2] = pm - 1;
	   }
	   else {
              reg [1] = am;
              reg [2] = pm;
	   }
	}
	else {		// fix for frequencies less than 45MHz
	   reg [1] = 0x06;
	   reg [2] = 0x11;
	}
//
//	fix clok out
	reg [6] |= 0x20;

	xin = (uint16_t)(doubleVCO - ((uint16_t)(doubleVCO / (CrystalFreqKhz/2))) * (CrystalFreqKhz/2));
	xin = (uint16_t)((xin << 15)/(CrystalFreqKhz / 2));

	if (xin >= (uint16_t) 16384 )
	   xin += (uint16_t) 32768;

	reg [3] = (uint8_t)(xin >> 8);
	reg [4] = (uint8_t)(xin & 0x00FF);

	//===================================== Only for testing
//	fprintf(stderr, "Frequency: %d, Fa: %x, Fp: %x, Xin:%x \n", Frequency, am, pm, xin);

	// Set Low-Pass Filter Bandwidth.
	switch (Bandwidth) {
	   case 6:
	      reg [6] = 0x80 | reg [6];
	      break;
	   case 7:
	      reg [6] = ~0x80 & reg[6];
	      reg [6] = 0x40 | reg[6];
	      break;
	   case 8:
	   default:
	      reg[6] = ~0xC0 & reg[6];
            break;
	}
//
//	modified for Realtek demod
	reg[5] = reg[5] | 0x07;

	for (i = 1; i <= 6; i ++) {
	   tmp = FC0013_Write (i, reg [i]);
//	   fprintf (stderr, "%d = FC0013_Write (%d, %d)\n", tmp, i, reg [i]);
	   if (tmp != FC0013_I2C_SUCCESS) {
	      fprintf (stderr, "FC0013_Write (%d, %d)\n", i, reg [i]);
	      goto error_status;
	   }
	}

	tmp = FC0013_Read (0x11, &read_byte);
	if (tmp != FC0013_I2C_SUCCESS)
	   goto error_status;

	if (multi == 64) {
	   if (FC0013_Write (0x11, read_byte | 0x04) != FC0013_I2C_SUCCESS)
	       goto error_status;
	}
	else {
	   if (FC0013_Write (0x11, read_byte & 0xFB) != FC0013_I2C_SUCCESS)
	          goto error_status;
	}

//	VCO Calibration
	ret = FC0013_Write (0x0E, 0x80);
	if (ret == FC0013_I2C_SUCCESS)
	   ret = FC0013_Write (0x0E, 0x00);
//	VCO recalibration if needed
	if (ret == FC0013_I2C_SUCCESS)
	   ret = FC0013_Write (0x0E, 0x00);
	if (ret != FC0013_I2C_SUCCESS)
	   goto error_status;


	ret = FC0013_Read (0x0E, &read_byte);
	if (tmp != FC0013_I2C_SUCCESS)
	   goto error_status;
	
	read_byte &= 0x3f;
	if (VCO1) {
           if (read_byte > 0x3C) {
              reg [6] &= ~0x08;
	      ret = FC0013_Write (0x06, reg[6]);
	      if (ret != FC0013_I2C_SUCCESS)
	         goto error_status;

	      ret = FC0013_Write (0x0E, 0x80);
	      if (ret != FC0013_I2C_SUCCESS)
	         goto error_status;
	      ret = FC0013_Write (0x0E, 0x00);
	      if (ret != FC0013_I2C_SUCCESS)
	         goto error_status;
           }
	}
	else {
           if (read_byte < 0x02) {
	      reg [6] |= 0x08;
	      ret = FC0013_Write (0x06, reg[6]);
	      if (ret != FC0013_I2C_SUCCESS)
	         goto error_status;

	      ret = FC0013_Write (0x0E, 0x80);
	      if (tmp != FC0013_I2C_SUCCESS)
	         goto error_status;

	      ret = FC0013_Write (0x0E, 0x00);
	      if (tmp != FC0013_I2C_SUCCESS)
	         goto error_status;
           }
	}

//	for (i = 1; i <= 0x15; i ++) {
//	   FC0013_Read (i, &read_byte);
//	   fprintf (stderr, "register [%d] = %x\n", i, read_byte);
//	}
	return 1;

error_status:
	return 0;
}
//
//	The interface functions
int32_t	TUNER_FC0013::init	(void) {
	return FC0013_Open ();
}

int32_t	TUNER_FC0013::exit	(void) {
	return 0;
}

int32_t	TUNER_FC0013::tune	(uint32_t freq) {
	Frequency	= freq;
	return FC0013_SetFrequency (freq/1000, 6);
}

int32_t	TUNER_FC0013::set_bw	(int32_t bw) {
	return FC0013_SetFrequency (Frequency /1000, 6);
}

bool	TUNER_FC0013::legalFrequency	(uint32_t kf) {
	return 45000 <= kf && kf <= 1600000;
}

bool	TUNER_FC0013::setGain (int32_t gain) {
int	ret;
bool	gainshift	= false;
bool	en_in_chg	= false;
uint8_t	read_byte;

	ret	= FC0013_Read (0x14, &read_byte);

	/* mask bits off	*/
	read_byte	&= 0xe0;

	switch (gain) {
	   case -63:		// - 6.3 db
	      break;

	   case 71:
	      read_byte |= 0x08;	// 7.1 db
	      break;

	   case 191:
	      gainshift = true;
	      read_byte |= 0x11;	// 19.1 db	
	      break;

	   default:
	   case 197:
	      en_in_chg = true;
	      gainshift = true;
	      read_byte |= 0x10;
	      break;
	}

	// set gain
	ret = FC0013_Write (0x14, read_byte);
	ret = FC0013_Read  (0x0a, &read_byte);

	if (en_in_chg)
	   read_byte |= 0x20;
	else
	   read_byte &= ~0x20;

	ret = FC0013_Write (0x0a, read_byte);

	// set gainshift
	ret = FC0013_Read (0x07, &read_byte);
	read_byte &= 0xf0;
	read_byte |= gainshift ? 0x0a : 0x07;
	return ret == FC0013_I2C_SUCCESS;
}


