#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _NOXON_RIG
#define	_NOXON_RIG

#include	"virtualrig.h"
#include	"ringbuffer.h"
#include	"fir-filters.h"

class	Oscillator;

#ifdef __MINGW32__
#define	DECIMATION_FIR_SIZE	21
#else
#define	DECIMATION_FIR_SIZE	61
#endif

class	RTL2832U;
/*
 */
class	noxonRig: public virtualRig {
public:
			noxonRig	(int32_t,  int32_t, int16_t, bool *);
			~noxonRig	(void);
	void		setVFOFrequency	(int32_t);
	void		getVFOFrequency	(int32_t *);
	bool		legalFrequency	(int32_t);
	int32_t		defaultFrequency	(void);
const	char		*nameofRig	(void);

//	reader
	bool		restartReader	(void);
	void		stopReader	(void);
	int32_t		getSamples	(DSPCOMPLEX *, int32_t, uint8_t);
	int32_t		getSamplesandSkip (DSPCOMPLEX *, int32_t, int32_t);
	uint32_t	getSampleCount	(void);
	int32_t		Samples		(void);
	RingBuffer<uint8_t>	*_I_Buffer;
	bool		readerRunning;
	uint32_t	sampleCounter;
	int32_t		oversampling;
	bool		RigprovidesSamples	(void);
private:
	bool		rig_is_ok;
	RTL2832U	*usbInterface;
	int32_t		sampleRate;
	int32_t		deviceCount	(void);
const	char		*deviceName	(int32_t);
	DecimatingFIR	*lowpass;
	Oscillator	*shifter;
	int32_t		tuningShift;
	bool		decimator;
};
#endif

