#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __VIRTUAL_TUNER
#define	__VIRTUAL_TUNER

#include	<stdint.h>

class	virtual_tuner {
public:
			virtual_tuner	(void);
virtual			~virtual_tuner	(void);
virtual	int32_t		init		(void);
virtual	int32_t		exit		(void);
virtual	int32_t		tune		(uint32_t f);
virtual	int32_t		get_frequency	(void);
virtual	int32_t		set_bw		(int32_t f);
virtual	int32_t		set_gain	(int32_t bw);
virtual	int32_t		get_gain	(void);
virtual	int32_t		set_correction	(int32_t);
virtual	int32_t		get_correction	(void);
virtual	bool		legalFrequency	(uint32_t);
	uint32_t	Frequency;
private:
	int32_t		correction;
	int32_t		gain;
};

#endif

