#
#ifndef	VREADER
#define	VREADER
#include	"stdio.h"
#include	"stdint.h"
#include	"jff-include.h"
#include	"samplerate.h"

class VReader {
public:
		VReader	(void);
virtual		~VReader (void);
virtual	int32_t	addtoBuffer	(int16_t *buffer, int32_t amount);
virtual	void	restart		(int32_t);
virtual	int32_t	Samples		(void);
virtual	int32_t	getSamples	(DSPCOMPLEX *, int32_t, uint8_t);
virtual	void	stop		(void);
virtual	void	setInputRate	(int32_t);
virtual	bool	RigprovidesSamples	(void);
};

#include	"fir-filters.h"
#include	"ringbuffer.h"

class	dongleReader :public VReader {
public:
			dongleReader	(int32_t);
			~dongleReader	(void);
	int32_t		addtoBuffer	(int16_t *buffer, int32_t amount);
	int32_t		Samples		(void);
	int32_t		getSamples	(DSPCOMPLEX *, int32_t, uint8_t);
	void		setInputRate	(int32_t);
	bool		RigprovidesSamples	(void);
private:
	int32_t		inputRate;
	int32_t		outputRate;
	double		realScale;
	int32_t		decimatingScale;
	DecimatingFIR	*lowpass;
	RingBuffer<int16_t>	*_I_Buffer;
	SRC_STATE	*converter;
	SRC_DATA	*src_data;
};

#endif

