#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include	"no_rig.h"
#include	"jff-include.h"

	no_rig::no_rig	(void) {
	lastFrequency = 14000000;
}

	no_rig::~no_rig	(void) {
}

bool	no_rig::isWorking	(void) {
	return true;
}

void	no_rig::setVFOFrequency	(int32_t f) {
	lastFrequency = f;
}

void	no_rig::getVFOFrequency	(int32_t *f) {
	*f = lastFrequency; 
}

bool	no_rig::legalFrequency	(int64_t f) {
	(void)f;
	return true;
}

const char	*no_rig::nameofRig	(void) {
	return "no rig";
}

bool	no_rig::restartReader	(void) {
	return false;
}

void	no_rig::stopReader	(void) {
}

int32_t	no_rig::getSamples	(DSPCOMPLEX *v, int32_t a, uint8_t m) {
	(void)v; (void)a; (void)m;
	return 0;
}

int32_t	no_rig::Samples		(void) {
	return 0;
}

bool	no_rig::RigprovidesSamples	(void) {
	return false;
}

bool	no_rig::isNO_RIG	(void) {
	return true;
}

