#
/*
 * 	
 * 	PMSDR_USB	
 * 	The usb interface handler for the pmsdr.
 *
 * 	This is a rewrite of parts of the code of:
 *	PMSDR command line manager (experimental)
 *
 *	Control a PMSDR hardware on Linux
 *	Modified to comply to firmware version 2.1.x
 *	Copyright (C) 2008,2009,2010  Andrea Montefusco IW0HDV, Martin Pernter IW3AUT

 *	This program is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation, either version 3 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef	__PMSDR_USB
#define __PMSDR_USB

#include	<stdlib.h>
#include	<string.h>
#include	<stdint.h>
#include	<QObject>
//#ifdef __MINGW32__
//#include	<libusb.h>
//#else
#include	<libusb-1.0/libusb.h>
//#endif

class	RadioInterface;

class	pmsdr_usb: public QObject {
Q_OBJECT
public:
			pmsdr_usb	(RadioInterface *);
			~pmsdr_usb	(void);
	bool		statusDevice	(void);
	
	bool		doTransaction	(uint8_t *, int16_t,
	                                 uint8_t *, int16_t *);
	int		get_transactions (int *, int *, int *);
	const char	*getError	(void);
	bool		open		(void);

private:
	bool		releaseDevice	(struct libusb_device_handle *);
	void		close		(struct libusb_device_handle *);

	RadioInterface	*mainInterface;

	uint8_t		*pszManufacturer;
	uint8_t		*pszProduct;
	bool		deviceOK;
	int16_t		usbError;

	struct libusb_device_handle	*devh;
signals:
	void		DeviceError	(int);
};

#endif

