#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _REPLAY_RIG
#define	_REPLAY_RIG

#include	"virtualrig.h"
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<QThread>
#include	"jff-include.h"
#include	"ringbuffer.h"
#include	"samplerate.h"
#include	<sndfile.h>
#include	<QString>
/*
 */
class	replayRig: public virtualRig, QThread {

public:
			replayRig		(int32_t, char *, bool *);
			~replayRig		(void);
	bool		isWorking	(void);
	void		setVFOFrequency	(int32_t);
	void		getVFOFrequency	(int32_t *);
	bool		legalFrequency	(int32_t);
const	char		*nameofRig	(void);

virtual void		run		(void);
//	reader
	bool		restartReader	(void);
	void		stopReader	(void);
	int32_t		getSamples	(DSPCOMPLEX *, int32_t, uint8_t);
	int32_t		Samples		(void);
	bool		RigprovidesSamples	(void);
private:
	int32_t		rate;
	char		*fileName;
	RingBuffer<float>	*_I_Buffer;

	int32_t		readBuffer	(float *data, int32_t length);
	SNDFILE		*filePointer;
	bool		readerOK;
	int32_t		sampleRate;
	int16_t		bitsperSample;
	int32_t		samplesinFile;
	int32_t		currPos;
	int16_t		numofChannels;
	bool		ExitCondition;
	bool		ThreadFinished;
	bool		readerPausing;
};
#endif

