#
/*
 *
 *    Copyright (C) 2008, 2009
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include	"virtualrig.h"

/*
 * 	The mother of all rigs
 */
	virtualRig::virtualRig	(void) {
	lastFrequency	= 14070000;	// just a dummy
	vfoOffset	= 0;
}

	virtualRig::~virtualRig	(void) {
}

void	virtualRig::setVFOFrequency	(int32_t f) {
	lastFrequency	= f;
}

void	virtualRig::getVFOFrequency	(int32_t *f) {
	*f = lastFrequency;
}

void	virtualRig::setFilter		(int16_t f) {
	(void)f;
}

void	virtualRig::setFilter		(int32_t freq, int16_t *f) {
	*f	= 0;
	(void)freq;
}

bool	virtualRig::isPMSDR		(void) {
	return false;
}

bool	virtualRig::isNO_RIG		(void) {
	return false;
}

bool	virtualRig::isDONGLE		(void) {
	return false;
}

bool	virtualRig::legalFrequency	(int32_t f) {
	(void)f;
	return true;
}

int32_t	virtualRig::defaultFrequency	(void) {
	return 14070000;
}

void	virtualRig::setOffset		(int32_t o) {
	vfoOffset	= KHz (o);
}

const char	*virtualRig::nameofRig		(void) {
	return "virtualRig";
}

void	virtualRig::displayVFO		(void) {
}

bool	virtualRig::restartReader	(void) {
	return false;
}

void	virtualRig::stopReader		(void) {
}

int32_t	virtualRig::getSamples		(DSPCOMPLEX *v, int32_t a, uint8_t m) {
	(void)v;
	(void)a;
	(void)m;
	return 0;
}

int32_t	virtualRig::Samples		(void) {
	return 0;
}

bool	virtualRig::RigprovidesSamples	(void) {
	return	false;
}

void	virtualRig::raiseSignal		(void) {
	samplesAvailable	();
}

void	virtualRig::dllRequest	(int n) {
	setDLLRequest (n);
}

void	virtualRig::haltReader	(void) {
}

