#
/*
 *
 *    Copyright (C) 2010, 2011, 2012
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in ESDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _VIRTUAL_RIG
#define	_VIRTUAL_RIG

#include	<stdlib.h>
#include	<stdio.h>
#include	<math.h>
#include	<string.h>
#include	<unistd.h>
#include	<stdint.h>
#include	<QObject>
#include	"ringbuffer.h"
#include	"jff-include.h"

#define	RIG_OK			0
#define	RIG_ERROR		255

class	virtualRig: public QObject {
Q_OBJECT
public:
		virtualRig	(void);
	virtual	~virtualRig	(void);
virtual	void	setVFOFrequency	(int32_t);
virtual	void	getVFOFrequency	(int32_t *);
virtual void	setFilter	(int16_t);
virtual void	setFilter	(int32_t, int16_t *);
virtual	bool	legalFrequency	(int32_t);
virtual int32_t	defaultFrequency	(void);
virtual const	char	*nameofRig	(void);
virtual	bool	isPMSDR		(void);
virtual	bool	isNO_RIG	(void);
virtual	bool	isDONGLE	(void);
virtual	void	displayVFO	(void);
virtual	void	setOffset	(int32_t);
//
//	interface to the reader
virtual	bool	restartReader	(void);
virtual void	stopReader	(void);
virtual	int32_t	getSamples	(DSPCOMPLEX *, int32_t, uint8_t);
virtual	int32_t	Samples		(void);
virtual	bool	RigprovidesSamples	(void);
virtual	void	haltReader	(void);
	int32_t	lastFrequency;
	int32_t	vfoOffset;
	void	raiseSignal	(void);
	void	dllRequest	(int32_t);
signals:
	void	samplesAvailable	(void);
	void	setDLLRequest		(int);
};
#endif

