#
/*
 *
 *    Copyright (C) 2009, 2010, 2011
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in ESDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with ESDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef	_FILTERING
#define	_FILTERING

#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>
#include	"jff-include.h"
#include	"fft.h"
#include	<QObject>
#include	"fft-filters.h"
#include	"utilities.h"
#include	"oscillator.h"
/*
 */
class	LowPassIIR;
class	Oscillator;
class	average;

class	Filtering: public QObject {
Q_OBJECT
public:
	Filtering		(int32_t, int32_t, DSPCOMPLEX *);
	~Filtering		(void);
	DSPCOMPLEX	HandleSampleHighSpeed	(DSPCOMPLEX);
	DSPCOMPLEX	BandPassLowSpeed	(DSPCOMPLEX);
	void		setWorkingRate		(int32_t);
	void		setSelectedBandto	(int32_t, int32_t, int32_t);
	void		setSelectedFrequencyto	(int32_t, int32_t, int32_t);
private:
	int16_t		FromdbtoS		(float);
	DSPFLOAT	S_Meter			(DSPCOMPLEX);
	DSPFLOAT	S_attack;
	DSPFLOAT	S_decay;
	int32_t		delayCount;
	DSPCOMPLEX	sampleSum;

	int32_t		_CardRate;
	int32_t		_WorkingRate;
	fftFilter	*BandPassFilter;
	fftFilter	*LowPassHighRate;
	fftFilter	*BandPassLowRate;
	Oscillator	*LocalOscillator;
	int16_t		filterDegree;
	int32_t		TunedIF;

signals:
	void		showPeak	(int, double);
};

#endif

