#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include	"deemphasis.h"

	DeemphasisFilter::DeemphasisFilter (void) {
	   a0	= 1.0;
	   a1	= -0.650981409543875;
	   b0	= 0.174509295228082;
	   b1	= 0.174509295228082;
	   gain	= 1;
	   m1	= 0;
	   m2	= 0;
}

	DeemphasisFilter::~DeemphasisFilter (void) {
}

DSPCOMPLEX	 DeemphasisFilter::Pass (DSPCOMPLEX z) {
DSPCOMPLEX o, w;

	o = cmul (z,  gain);
	w = o - cmul (m1, b0) - cmul (m2, b1);
	o = w + cmul (m1, a0) + cmul (m2, a1);
	m2 = m1;
	m1 = w;
	return o;
}


