#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *     The fax implementation is a rewrite of hamfax
 *      Copyright (c) 2001, 2002
 *	Christof Schmitt, DH1CS <cschmitt@users.sourceforge.net>
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef	__DEMODULATOR
#define	__DEMODULATOR

#include	"jff-include.h"
#include	"fir-filters.h"
#include	"iir-filters.h"

class	Demodulator {
public:
			Demodulator (int8_t, int32_t, int32_t);
			~Demodulator ();
	int16_t		demodulate	(DSPCOMPLEX);
	int16_t		demodulate_1	(DSPCOMPLEX);
	int16_t		demodulate_2	(DSPCOMPLEX);
	int16_t		demodulate_3	(DSPCOMPLEX);
	int16_t		demodulate_4	(DSPCOMPLEX);
	void		setMode		(int8_t);
	void		setDeviation	(int16_t);
	void		select		(int8_t);
private:
	int8_t		mode;
	int32_t		Rate;
	int32_t		deviation;
	DSPFLOAT	Qmin1;
	DSPFLOAT	Qmin2;
	DSPFLOAT	Imin1;
	DSPFLOAT	Imin2;
	int16_t		ArcsineSize;
	double		*Arcsine;
	DSPCOMPLEX	*Table;
	DSPFLOAT	pll_integrator;
	LowPassIIR	*pll_Lowpass;
	DSPCOMPLEX	fax_oldz;
	int8_t		selector;
};

#endif

