#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in ESDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef	OLIVIA_DECODER
#define	OLIVIA_DECODER

#include	"jff-include.h"
#include	"virtualdecoder.h"
#include	"utilities.h"
#include	"pj_mfsk.h"

class	RadioInterface;

class oliviaDecoder: public virtualDecoder {
Q_OBJECT
public:
			oliviaDecoder	(int32_t, RadioInterface *);
			~oliviaDecoder	(void);
	DSPCOMPLEX	doDecode	(DSPCOMPLEX);
	void		restart		(void);

	void		setWorkingRate		(int32_t);
	void		olivia_setTones		(int16_t);
	void		olivia_setBW		(int16_t);
	void		olivia_setSyncMargin	(int16_t);
	void		olivia_setSyncIntegLen	(int16_t);
	void		olivia_setSquelch	(bool);
	void		olivia_setSquelchvalue	(int16_t);
	void		olivia_setReverse	(bool);
private:
	int16_t		unescape	(int16_t);
	MFSK_Receiver<DSPFLOAT>	*Receiver;
	bool		escape;
	bool		reverse;
	int32_t		SampleRate;
	RadioInterface	*MyRadioInterface;
	DSPFLOAT	*oliviaBuffer;
	int16_t		inp;
	int32_t		baseFrequency;
	int32_t		frequency;
	DSPFLOAT	snr;
	char		*msg1;
	char		*msg2;
	int16_t		Tones;
	int16_t		Bandwidth;
	int16_t		SyncMargin;
	int16_t		SyncIntegLen;
	DSPFLOAT	SyncThreshold;
	int16_t		bw;
	bool		SquelchOn;
	int16_t		squelchValue;

	int32_t		lastFreq;

signals:
	void		clrText		(void);
	void		addChar		(char);
	void		put_Status1	(char *);
	void		put_Status2	(char *);
	void		setDetectorMarker	(int);
};

#endif
