#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#
#include	"gui.h"
#include	"sdrdecoder.h"

	sdrDecoder::sdrDecoder (int32_t workingR, RadioInterface *RI) {
	_WorkingRate		= workingR;
	MyRadioInterface	= RI;

	connect (this,
	         SIGNAL (addtoIQplot (double, double)),
	         MyRadioInterface,
	         SLOT (addtoIQplot (double, double)));
	connect (this,
	         SIGNAL (setDetectorMarker (int)),
	         MyRadioInterface,
	         SLOT (setDetectorMarker (int)));
	setDetectorMarker	(0);
}

	sdrDecoder::~sdrDecoder () {
	disconnect (this,
	            SIGNAL (addtoIQplot (double, double)),
	            MyRadioInterface,
	            SLOT (addtoIQplot (double, double)));
	disconnect (this,
	            SIGNAL (setDetectorMarker (int)),
	            MyRadioInterface,
	            SLOT (setDetectorMarker (int)));
	setDetectorMarker	(0);
}

void	sdrDecoder::setWorkingRate	(int32_t workingRate) {
	_WorkingRate	= workingRate;
}


DSPCOMPLEX	sdrDecoder::doDecode (DSPCOMPLEX z) {
	addtoIQplot (real (z), imag (z));
//	return DSPCOMPLEX (real (z), imag (z));
	return DSPCOMPLEX (real (z) - imag (z), 0);
}


