#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (ESDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _SDR_DECODER
#define	_SDR_DECODER
#
/*
 */
#include	"jff-include.h"
#include	"iir-filters.h"
#include	"fir-filters.h"
#include	"virtualdecoder.h"
#include	"fft.h"

class	RadioInterface;
/*
 */

class sdrDecoder: public virtualDecoder {
Q_OBJECT
public:
	        sdrDecoder		(int32_t, RadioInterface *);
		~sdrDecoder		(void);
	void	setWorkingRate		(int32_t);
	DSPCOMPLEX	doDecode	(DSPCOMPLEX);

private:
	RadioInterface		*MyRadioInterface;
	int32_t			_WorkingRate;
	int32_t			scaler;
	int32_t			cnt;

signals:
	void	addtoIQplot	 (double, double);
	void	setDetectorMarker	(int);
};
#endif

