#
/*
 *
 *    Copyright (C) 2008
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with ESDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _INTERLEAVER
#define	_INTERLEAVER
#
#include	"jff-include.h"

class	Interleaver {
public:
		Interleaver (int16_t, int16_t, uint8_t);
		~Interleaver ();
	void	InterleaveSyms (uint8_t	*syms);
	void	InterleaveBits (uint32_t  *bits);

	enum Mode {
	INTERLEAVE_FWD	=	0,
	INTERLEAVE_REV	=	1
	};

private:
	uint8_t get (int16_t, int16_t, int16_t);
	void	set (int16_t, int16_t, int16_t, uint8_t);
	int16_t	size;
	uint8_t	dir;
	int16_t	rep;
	uint8_t	*table;
};
#endif

