#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef	_SPECTRUM_MANAGER
#define	_SPECTRUM_MANAGER

#include	<stdlib.h>
#include	<stdio.h>
#include	<stdexcept>
#include	<iostream>
#include	"jff-include.h"
#include	<QObject>
#include	"fft.h"

#define	FFT_TWOSIDES	0100
#define	FFT_POSITIVE	0101
#define	FFT_NEGATIVE	0102

#define	FILLING		100
#define	NEWSPECTRUM	001

class	spectrumManager: public QObject {
Q_OBJECT
public:
		spectrumManager	(uint16_t,	//fillpoint
	                         uint16_t,	//displaySize
	                         uint32_t,	//max frequency
	                         uint8_t);	//Mode of operation
		~spectrumManager	();
	void	addElement		(DSPCOMPLEX);
	void	addElements		(DSPCOMPLEX *, int);
	double	getSpectrumPower	(int, int);
	int	Binfor			(int);
	double	Binwidth		(void);
	double	getDisplayXelement	(int);
	double	getDisplayYelement	(int);
	void	Restart			(int);
	void	setModeofOperation	(uint8_t);
private:
	int		getSpectrumSizefor (int);
	uint16_t	spectrumFillpoint;
	uint16_t	spectrumSize;
	uint16_t	displaySize;
	uint8_t		ModeofOperation;
	int		MaxFrequency;
	int		cnt;
	double		binWidth;
	common_fft	*spectrum_fft;
	DSPCOMPLEX	*spectrumBuffer;
	double		*Window;
	double		*spectrumWindow;
	double		*X_axis;
	double		*displayBuffer;
signals:
	void		ReadyforDisplay (double *, double *, int);
};
	
#endif
